<?php

namespace PurchasingBundle\Repository;


use PurchasingBundle\Entity\Package;
use Schema\SchemaEntityRepository;
use Doctrine\Common\Persistence\ManagerRegistry;
use Psr\Log\LoggerInterface;
use Utils\StaticUtil\LogUtils;

/**
 * PackageRepository
 *
 * This class was generated by the Doctrine ORM. Add your own custom
 * repository methods below.
 */
class PackageRepository extends SchemaEntityRepository {


    /** @var LoggerInterface $logger */
    private $logger;

    /**
     * PackageRepository constructor.
     * @param ManagerRegistry $registry
     * @param LoggerInterface $logger
     */
    public function __construct(ManagerRegistry $registry, LoggerInterface $logger) {
        parent::__construct($registry, Package::class);

        $this->logger = $logger;
    }

    /**
     * @param int $type
     * @return array|mixed
     */
    public function findAllActivePackagesByType ($type = Package::TYPE_PUBLIC) {

        $qb = $this->getEntityManager()->createQueryBuilder();
        $qb->select('p')
            ->from('PurchasingBundle:Package', 'p')
            ->where('(p.isDisabled IS NULL OR p.isDisabled=0) AND p.type = :type')
            ->setParameter('type', $type)
        ;

        $results = array();

        try {
            $results = $qb->getQuery()->getResult();
        } catch (\Exception $e) {
            $exception = LogUtils::getFormattedExceptions($e);
            $this->logger->error("Failed get all active packages", $exception);
        }

        return $results;
    }

}
